local Procodile = LibStub("AceAddon-3.0"):GetAddon("Procodile")
ProcodileFu = Procodile:NewModule("FuBar", "LibFuBarPlugin-Mod-3.0")

function ProcodileFu:OnModuleInitialize()
	self:SetFuBarOption('iconPath', "Interface\\Icons\\Spell_Holy_WordFortitude")
	self:SetFuBarOption('tooltipType', "GameTooltip")
	self:SetFuBarOption('configType', "AceConfigDialog-3.0")
	self:SetFuBarOption('defaultPosition', "RIGHT")
end

function ProcodileFu:OpenMenu()
	Procodile:OpenOptions()
end

function ProcodileFu:OnModuleEnable()
	Procodile:Print("ProcodileFu:OnModuleEnable")
end

function ProcodileFu:OnUpdateFuBarText()
	if Procodile:IsEnabled() then
		self:SetFuBarText("|cff22ff22Procodile")
	else
		self:SetFuBarText("|cffff2222Procodile")
	end
end

function ProcodileFu:OnUpdateFuBarTooltip()
    GameTooltip:AddLine("Procodile")
    
    local tracked = Procodile:GetTrackedSpells()
    
	for internalname,proc in pairs(tracked) do
		-- PPM
		local ppm = 0
		if proc.count > 0 then
			ppm = proc.count / (proc.totaltime / 60)
		end
		
		-- Uptime
		local uptime = 0
		if proc.seconds > 0 and proc.totaltime > 0 then
			uptime = proc.seconds / proc.totaltime * 100
		end
				
		GameTooltip:AddLine(proc.name)
		if proc.count > 0 then
		    GameTooltip:AddDoubleLine("Procs", proc.count)
		else
		    GameTooltip:AddDoubleLine("Procs", "none")
		end
			
	    if ppm > 0 then
		    GameTooltip:AddDoubleLine("PPM", string.format("%.2f", ppm))
		else
		    GameTooltip:AddDoubleLine("PPM","unknown")
		end
		
		if uptime > 0 then
		    GameTooltip:AddDoubleLine("Uptime", string.format("%.2f", uptime).."%")
		else
		    GameTooltip:AddDoubleLine("Uptime", "unknown")
		end
		
	    if proc.cooldown > 0 then
		    GameTooltip:AddDoubleLine("Cooldown", proc.cooldown.."s")
		else
		    GameTooltip:AddDoubleLine("Cooldown", "unknown")
		end
		GameTooltip:AddLine(" ")
	end

    GameTooltip:AddLine("Hint: Ctrl-Click to reset.", 0, 1, 0)
    GameTooltip:AddLine("Shift-click to toggle tracking.", 0, 1, 0)
    GameTooltip:AddLine("Right-click to configure", 0, 1, 0)
end

function ProcodileFu:OnFuBarEnter()
end

function ProcodileFu:OnFuBarLeave()
end

function ProcodileFu:OnFuBarClick(button)
	if button == "LeftButton" and IsShiftKeyDown() then
		Procodile:Toggle()
	elseif button == "LeftButton" and IsControlKeyDown() then
		Procodile:Reset()
	end
end